﻿using UnityEngine;
using HarmonyLib;

public class AlwaysCalmWeather : Mod
{
    private Harmony harmony;
    private static readonly string modId = "com.raftmodding.mods.always-calm-weather";

    public void Start()
    {
        harmony = new Harmony(modId);
        harmony.PatchAll();
        Debug.Log("Mod AlwaysCalmWeather has been loaded!");
    }

    public void OnModUnload()
    {
        harmony.UnpatchAll(modId);
        Debug.Log("Mod AlwaysCalmWeather has been unloaded!");
    }

    [HarmonyPatch(typeof(WeatherManager), "Update")]
    public class WeatherManagerUpdatePatch
    {
        [HarmonyPrefix]
        static bool Prefix(WeatherManager __instance)
        {
            __instance.SetWeather(UniqueWeatherType.Calm, true);
            return false;
        }
    }

    [HarmonyPatch(typeof(WeatherManager), "SetWeather", typeof(Weather), typeof(bool))]
    public class WeatherManagerSetWeatherPatch
    {
        [HarmonyPrefix]
        static bool Prefix(Weather weather, bool instant)
        {
            weather.so_weather.uniqueWeatherType = UniqueWeatherType.Calm;
            return weather.so_weather.uniqueWeatherType == UniqueWeatherType.Calm && instant;
        }
    }
}